package Aufgabe1;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public class EchoThread extends Thread {
	Socket sock;
	static List<Socket> syncList = Collections.synchronizedList(new LinkedList<Socket>());

	/**
	 * 
	 * @param sock
	 */
	public EchoThread(Socket sock) {
		this.sock = sock;
		EchoThread.syncList.add(sock);
	}

	@Override
	public void run() {
		try {
			BufferedReader netIn = new BufferedReader(new InputStreamReader(
					sock.getInputStream()));
			/*BufferedWriter netOut = new BufferedWriter(new OutputStreamWriter(
					sock.getOutputStream())); */
			String line;
			while ((line = netIn.readLine()) != null) {
				if (line.startsWith("/quit")){
					
					break;
					
				}
				synchronized(EchoThread.syncList){
					Iterator<Socket> iter= EchoThread.syncList.iterator();
					while(iter.hasNext()){
						BufferedWriter out =new BufferedWriter(new OutputStreamWriter(iter.next().getOutputStream()));
						out.write(line + "\n");
						out.flush();
						
					}
				}
				/*for(Socket sock: EchoThread.syncList){
					BufferedWriter out =new BufferedWriter(new OutputStreamWriter(sock.getOutputStream()));
					out.write(line + "\n");
					out.flush();
				}*/
			}
			
			EchoThread.syncList.remove(sock);
			sock.shutdownInput();
			sock.shutdownOutput();
			sock.close();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
